### Function

# Camel write

#### Declaration [src]

    gssize
    camel_write (
      gint fd,
      const gchar* buf,
      gsize n,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Cancellable libc `write()` replacement.

Code that intends to be portable to Win32 should call this function only on file descriptors returned from open(), not on sockets.

#### Parameters

`fd`

  Type: `gint`

  File descriptor.

`buf`

  Type: `const gchar*`

  Buffer to write.

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`n`

  Type: `gsize`

  Number of bytes of `buf` to write.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gssize`

Number of bytes written or -1 on fail. On failure, errno will be set appropriately.